
/* (c) 2002-2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "defines.h"
#include "console.h"
#include "txt.h"
#include "font.h"
#include "main.h"


extern int dirty_textures;

int console_txt, console_dx = 512, console_dy = 256;
int console_lines = 9, console_input_i = 2;
char *console_text, console_input_buffer[32];


int console_init(void) {

  int i;


  console_text = malloc(256 * console_lines);
  if (console_text == NULL) {
    fprintf(stderr, "CONSOLE_INIT: Out of memory error.\n");
    return FAILED;
  }

  for (i = 0; i < console_lines; i++)
    console_text[i*256] = 0;
  console_input_buffer[0] = '>';
  console_input_buffer[1] = ' ';

  txt_create("console", &console_txt, console_dx, console_dy);
  console_write("Welcome...");

  return SUCCEEDED;
}


int console_refresh_prompt(void) {

  console_clear();
  console_write_all();

  return SUCCEEDED;
}


int console_erase_char(void) {

  if (console_input_i == 2)
    return FAILED;
  console_input_i--;
  console_input_buffer[console_input_i] = 0;

  console_refresh_prompt();

  return SUCCEEDED;
}


int console_type_char(char c) {

  if (c == 0) {
    console_input_buffer[0] = '*';
    console_write(console_input_buffer);
    console_input_buffer[0] = '>';
    process_client_command(console_input_buffer + 2);
    console_input_i = 2;
    console_input_buffer[console_input_i] = 0;
    console_refresh_prompt();
    return SUCCEEDED;
  }

  if (console_input_i == 32)
    return FAILED;

  console_input_buffer[console_input_i] = c;
  console_input_i++;
  console_input_buffer[console_input_i] = 0;
  console_refresh_prompt();

  return SUCCEEDED;
}


int console_empty(void) {

  int i;


  for (i = 0; i < console_lines; i++)
    console_text[i*256] = 0;
  console_input_buffer[0] = '>';
  console_input_buffer[1] = ' ';
  console_refresh_prompt();

  return SUCCEEDED;
}


int console_clear(void) {

  struct txt_object *t;
  char *c;
  int i;


  txt_get(console_txt, &t);

  c = t->txt;
  for (i = 0; i < (console_dy*console_dx>>2); i++) {
    *(c++) = 0;
    *(c++) = 0;
    *(c++) = 100;
    c++;
    *(c++) = 0;
    *(c++) = 0;
    *(c++) = 100;
    c++;
    *(c++) = 0;
    *(c++) = 0;
    *(c++) = 100;
    c++;
    *(c++) = 0;
    *(c++) = 0;
    *(c++) = 100;
    c++;
  }

  t->dirty = YES;
  dirty_textures = YES;

  return SUCCEEDED;
}


int console_write_all(void) {

  struct txt_object *t;
  int i;


  txt_get(console_txt, &t);
  t->dirty = YES;
  dirty_textures = YES;
  console_clear();

  for (i = 0; i < console_lines; i++)
    font_write_string_transparent(t, console_text + i*256, 2, i*24);

  font_write_string_transparent(t, console_input_buffer, 2, i*24);

  return SUCCEEDED;
}


int console_write(char *c) {

  int i;


  for (i = 0; i < console_lines - 1; i++) {
    strcpy(console_text + 256*i, console_text + 256*(i+1));
  }
  strcpy(console_text + 256*i, c);

  console_write_all();

  return SUCCEEDED;
}
