
#include <GL/gl.h>

#include "../common/defines.h"

#ifndef M_PI
#define M_PI 3.14159265
#endif

/* define INGAME_DEBUG to be able to use command 'v' in the game console
   (for displaying some ingame information) */
#define INGAME_DEBUG 1

/* max amount of textures */
#define MAX_TEXTURES 512

#define EPSILON 0.1

/* the squared distance limit for lod 1 */
#define LOD_1_DISTANCE 400

/* the squared distance limit for particle systems */
#define LOD_DISTANCE_PARTICLES 200

/* the max amount of move items */
#define MOVE_ITEMS_MAX 128

/* visible objects are visible for this many next frames */
#define OC_FRAMES_VISIBLE 10
/* invisible objects are invisible for this many next frames */
#define OC_FRAMES_INVISIBLE -1

/* define this if you want to use depth-of-field */
/* note that your screen resolution must be such */
/* that opengl can use it as a texture           */
/*
#define USE_DOF 1
*/

/* field of view */
#define FOV_MIN  6
#define FOV_MAX 70

/* default screen size */
#define SCREEN_DX 1280
#define SCREEN_DY 1024

#define STATUS_CLEAR 0
#define STATUS_QUIT  1

#define PLAYER_MOTION_LEFT   1
#define PLAYER_MOTION_RIGHT  2
#define PLAYER_MOTION_UP     4
#define PLAYER_MOTION_DOWN   8
#define PLAYER_MOTION_RUN   16
#define PLAYER_ZOOM_IN      32
#define PLAYER_ZOOM_OUT     64
#define PLAYER_CROUCH      128

#define PLAYER_STATUS_MOVED 1

#define MAP_NOT_LOADED 0
#define MAP_LOADED 1

#define MOON_DISTANCE 200

/* object types */
#include "../data/obj/list.h"

/* structures */
#include "structures.h"
