
/* written by ville helin <vhelin@cc.hut.fi> in 2003 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "configuration.h"
#include "defines.h"



int configuration_read(char *name, struct configuration *c) {

  struct configuration *p;
  char tmp[256];
  FILE *f;
  int i;


  if (name == NULL || c == NULL)
    return FAILED;

  f = fopen(name, "rb");
  if (f == NULL) {
    fprintf(stderr, "CONFIGURATION_READ: Could not open file \"%s\" for reading.\n", name);
    return FAILED;
  }

  while (fscanf(f, "%255s", tmp) != EOF) {
    i = 0;
    p = &c[i];
    while (p != NULL && p->name != NULL) {
      if (strcmp(p->name, tmp) == 0) {
	if (p->type == CONFIGURATION_TYPE_INTEGER)
	  fscanf(f, "%d", (int *)p->pointer);
	else if (p->type == CONFIGURATION_TYPE_FLOAT)
	  fscanf(f, "%f", (float *)p->pointer);
	else if (p->type == CONFIGURATION_TYPE_DOUBLE)
	  fscanf(f, "%lf", (double *)p->pointer);
	else if (p->type == CONFIGURATION_TYPE_STRING)
	  fscanf(f, "%s", (char *)p->pointer);
	break;
      }
      i++;
      p = &c[i];
    }

    if (p == NULL)
      fprintf(stderr, "CONFIGURATION_READ: File \"%s\", unknown symbol \"%s\".\n", name, tmp);
  }

  fclose(f);

  return SUCCEEDED;
}
