
#include <GL/gl.h>
#include "common.h"

struct mesh2 {
  int  vertices;
  int  objects;
  int  triangles;
  int collision_status;
  float *vertex_list;
  float *vertex_normal_list;
  float *face_normal_list;
  float *uv_list;
  float *triangle_radius_list;
  float bounding_sphere_r;
  float bounding_sphere[3];
  int   object_data[2*16];  /* texture id, number of triangles */
};

struct object_mesh {
  char name[64];
  int vertices;
  int triangles;
  int collision_status;
  int *triangle_list;
  int *textures;
  /* landscape creator variables */
  int *triangle_cube;
  double *triangle_center_xyz;
  /* --------------------------- */
  double *vertice_list;
  float  *vertex_normal_list;
  float  *face_normal_list;
  float  *uv_list;
  float  *triangle_radius_list;
  double bounding_sphere_r;
  double bounding_sphere[3];
  struct object_mesh *next;
};

#define TXT_STATUS_NORMAL       0
#define TXT_STATUS_ALPHA        1
#define TXT_STATUS_NO_COLLISION 2

struct txt_object {
  int id;
  int x, y;
  int dirty;
  int status;
  int *size;     /* the images sizes */
  int type;      /* opengl type */
  int mipmaps;   /* the number of mipmaps */
  char *txt;
  char name[64];
  float alpha;
  GLuint ogl_name;
  double friction;
  double speed;
  unsigned char r, g, b;
};

struct txt_extra_info {
  int collision;
  char name[256];
  float alpha;
  unsigned char r, g, b;
  double friction, speed;
  struct txt_extra_info *next;
};
