
/* (c) 2002 ville helin <vhelin@cc.hut.fi> */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <signal.h>
#include <time.h>

#include "defines.h"
#include "socket.h"


int socket_create(int *s, int p, int l) {

  struct sockaddr_in name;


  *s = socket(PF_INET, SOCK_STREAM, 0);
  if (*s < 0) {
    fprintf(stderr, "SOCKET_CREATE: Error creating a new socket.\n");
    return FAILED;
  }

  name.sin_port = htons(p);
  name.sin_addr.s_addr = htonl(INADDR_ANY);
  if (bind(*s, (struct sockaddr *)&name, sizeof(name)) < 0) {
    socket_delete(*s);
    fprintf(stderr, "SOCKET_CREATE: Error binding port %d to a new socket.\n", p);
    return FAILED;
  }

  /* do we want to listen to the socket? */
  if (l == YES) {
    if (listen(*s, 1) < 0) {
      fprintf(stderr, "SOCKET_CREATE: Error listening to a socket.\n");
      socket_delete(*s);
      return FAILED;
    }
  }

  fprintf(stderr, "SOCKET_CREATE: Obtained port %d.\n", p);

  return SUCCEEDED;
}


int socket_delete(int s) {

  if (shutdown(s, SHUT_RDWR) >= 0)
    return SUCCEEDED;
  else if (close(s) >= 0)
    return SUCCEEDED;

  return FAILED;
}
