
#define OFF 0
#define ON 1

#define FAILED 0
#define SUCCEEDED 1

#define NO 0
#define YES 1

#define EPSILON 0.004

#ifndef M_PI
#define M_PI 3.14159265
#endif

/* MAP_SIZE must be (2^n)+1 (a restriction coming from
   the fractal algorithm */
#define MAP_SIZE 129

#define MAP_GENERATOR_AREAS 3

/* different areas on the map */
#define MAP_AREA_UNDEFINED 100
#define MAP_AREA_UNDER_THE_SEA 0
#define MAP_AREA_GRASSLANDS 1
#define MAP_AREA_MOUNTAIN 2

/* object types */
#include "../data/obj/list.h"

/* one 2D map pixel side equals to... in the 3D world */
#define MAP_PIXEL_SIDE_SCALE 1.0

/* fractal generator init values */
#define DEF_LIMIT 40
#define DEF_DIVISOR 1.8
#define DEF_RANDOM_XY 0

#define LIMIT_SEA    1.0
#define LIMIT_GRASS 40.0

/* local minima and maxima */
#define MAP_MIN 1
#define MAP_MAX 2

/* plant object */
struct plant {
  int type;
  double x, y, z;
  float rx, ry, rz;
  struct plant *next;
};

/* particle system */
struct psystem {
  int type;
  double x, y, z;
  float rx, ry, rz;
  struct psystem *next;
};

/* house */
struct house {
  double x, y, z;
  int dx, dy;
  struct house *next;
};

struct vector {
  double x, y, z;
};
