
/* (c) 2003 ville helin <vhelin@cc.hut.fi> */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

#include "defines.h"
#include "../common/defines.h"
#include "txt.h"


struct txt_object **txt_table = NULL;
int txt_id_conversion = ON;



int txt_init(void) {

  int i;


  txt_table = malloc(sizeof(struct txt_object *) * 512);
  if (txt_table == NULL) {
    fprintf(stderr, "TXT_INIT: Out of memory error.\n");
    return FAILED;
  }

  for (i = 0; i < 512; i++)
    txt_table[i] = NULL;

  return SUCCEEDED;
}


int txt_load(char *n, int *id) {

  struct txt_object *t;
  static int txt_id = 0;
  char c[256];
  int i;


  for (i = 0; i < 512; i++) {
    t = txt_table[i];
    if (t == NULL)
      continue;
    if (strcmp(n, t->name) == 0) {
      *id = i;
      return SUCCEEDED;
    }
  }

  t = malloc(sizeof(struct txt_object));
  if (t == NULL) {
    fprintf(stderr, "TXT_LOAD: Out of memory error.\n");
    return FAILED;
  }

  t->id = txt_id;
  txt_table[txt_id] = t;
  *id = txt_id;
  txt_id++;
  strcpy(t->name, n);
  strcpy(c, "data/txt/");
  strcat(c, n);

  return SUCCEEDED;
}


int txt_create(char *n, int *id, int dx, int dy) {

  struct txt_object *t;
  static int txt_id = 0;
  char c[256];
  int i;


  for (i = 0; i < 512; i++) {
    t = txt_table[i];
    if (t == NULL)
      continue;
    if (strcmp(n, t->name) == 0) {
      *id = i;
      return SUCCEEDED;
    }
  }

  t = malloc(sizeof(struct txt_object));
  if (t == NULL) {
    fprintf(stderr, "TXT_CREATE: Out of memory error.\n");
    return FAILED;
  }

  t->id = txt_id;
  txt_table[txt_id] = t;
  *id = txt_id;
  txt_id++;
  strcpy(t->name, n);
  strcpy(c, "data/txt/");
  strcat(c, n);

  return SUCCEEDED;
}


int txt_get(int id, struct txt_object **t) {

  *t = txt_table[id];

  if (*t == NULL) {
    fprintf(stderr, "TXT_GET: Unknown texture %d.\n", id);
    return FAILED;
  }

  return SUCCEEDED;
}
